﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Tutorial_CS_Kaufhaus_Sets
{
    internal class Ware:IComparable<Ware>
    {
        public string Bezeichnung { get; set; }
        public double Preis { get; set; }
        public override string ToString()
        {
            return Bezeichnung + "|" + Preis;
        }

        //wann sind zwei Objekte gleich 
        public override bool Equals(object obj)
        {
            if(obj is Ware)
            {
                Ware other = obj as Ware;
                return this.Bezeichnung.Equals(other.Bezeichnung) && this.Preis == other.Preis;
            }
            return false;
        }

        //wann sind Objekte ähnlich 
        public override int GetHashCode()
        {
            return Bezeichnung.Length;
        }

        //w1.CompareTo(w2)
        //Rückgabe > 0: this steht in Reihenfolge nach obj
        //Rückgabe < 0: this steht in Reihenfolge vor obj
        //Rückgabe 0: gleich
        public int CompareTo(Ware other)
        {
            //Sortierung aufsteigend nach bezeichnung
            //this = Schuhe / other = Lamadecke

            return this.Bezeichnung.CompareTo(other.Bezeichnung);
        }
    }

    class Vergleich : IEqualityComparer<Ware>
    {
        public bool Equals(Ware x, Ware y)
        {
            return x.Bezeichnung.Equals(y.Bezeichnung);
        }

        public int GetHashCode(Ware obj)
        {
            return obj.Bezeichnung.Length;
        }
    }
}
